// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <math.h>

// .h subor
#include "m3Dmath.h"

// konstruktor *************************************************************
m3Dmath::m3Dmath()
{

}

// destruktor **************************************************************
m3Dmath::~m3Dmath()
{

}

// vrati absolutnu hodnotu cisla *******************************************
unsigned int m3Dmath::myAbs(int N)
{
 if (N<0) return (0-N);

 return N;
}

// vypocet rovnice roviny **************************************************
void m3Dmath::CalcPlane(s3DObject *obj,s3DFace *face)
{
 // priprava vrcholov (pre sprehladnenie neskorsieho zapisu)
 for (i=0;i<3;i++) {
  p[i+1].x=obj->points[face->p[i]].x;
  p[i+1].y=obj->points[face->p[i]].y;
  p[i+1].z=obj->points[face->p[i]].z;
 }
 // vypocet prvkov a,b,c, ktore su zaroven prvkami normaloveho vektora facu
 // jedna sa o vektorovy sucin vektorov 1->2 a 1->3
 face->PlaneEq.a=(p[2].y-p[1].y)*(p[3].z-p[1].z)-(p[3].y-p[1].y)*(p[2].z-p[1].z);
 face->PlaneEq.b=(p[2].z-p[1].z)*(p[3].x-p[1].x)-(p[3].z-p[1].z)*(p[2].x-p[1].x);
 face->PlaneEq.c=(p[2].x-p[1].x)*(p[3].y-p[1].y)-(p[3].x-p[1].x)*(p[2].y-p[1].y);
 // dosadenim 1. vrcholu do rovnice vypocitame prvok d
 face->PlaneEq.d=-(face->PlaneEq.a*p[1].x+face->PlaneEq.b*p[1].y+face->PlaneEq.c*p[1].z);
}

// nasobenie matice vektorom ***********************************************
void m3Dmath::MatrixMul(_matrix M,_vector V)
{
 q[0]=M[0]*V[0]+M[4]*V[1]+M[8]*V[2]+M[12]*V[3];
 q[1]=M[1]*V[0]+M[5]*V[1]+M[9]*V[2]+M[13]*V[3];
 q[2]=M[2]*V[0]+M[6]*V[1]+M[10]*V[2]+M[14]*V[3];
 q[3]=M[3]*V[0]+M[7]*V[1]+M[11]*V[2]+M[15]*V[3];
 V[0]=q[0];
 V[1]=q[1];
 V[2]=q[2];
 V[3]=q[3];
}
