#ifndef _M3DMATH_H_
#define _M3DMATH_H_

typedef float _vector[4];  // pre ulozenie obsahu 4-prvkoveho vektora
typedef float _matrix[16]; // pre ulozenie obsahu OpenGL matice

typedef struct s3DPoint // suradnice vrchola (3-prvkoy vektor)
{
 float x,y,z;
};

typedef struct s3DPlaneEq // rovnica roviny (ax+by+cz+d=0)
{
 float a,b,c,d;
};

typedef struct s3DFace // 3D face (stena) objektu
{
 bool visible;          // face je privrateny/odvrateny voci svetlu

 unsigned int p[3];     // indexy vrcholov tvoriacich face
 s3DPlaneEq PlaneEq;    // rovnica roviny, v ktorej lezi face
 s3DPoint normals[3];   // normaly v jednotlivych vrcholoch

 unsigned int neigh[3]; // indexy susednych facov
};

typedef struct s3DObject // 3D objekt
{
 unsigned int nPoints; // pocet vrcholov
 s3DPoint points[100]; // pole vrcholov

 unsigned int nFaces;  // pocet facov
 s3DFace faces[200];   // pole facov
};

// trieda matematicko-geometrickych vypoctov
class m3Dmath {
public:
 m3Dmath();          // konstruktor
 virtual ~m3Dmath(); // destruktor

 unsigned int myAbs(int N); // vrati absolutnu hodnotu cisla

 void CalcPlane(s3DObject *obj,s3DFace *face); // vypocet rovnice roviny

 void MatrixMul(_matrix M,_vector V); // nasobenie matice vektorom
private:
 unsigned int i; // pomocna premenna

 s3DPoint p[4];  // pomocna premenna

 float q[4];     // pomocna premenna
};
 
#endif
