// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// .h subor
#include "mOGL.h"

GLUquadricObj *qo; // quadratic objekt

// konstruktor *************************************************************
mOGL::mOGL()
{
 Cnum=0;

 // rozmery okna
 ViewPort[0]=0; ViewPort[1]=0; ViewPort[2]=0; ViewPort[3]=0;

 StartInfoPos=10.0f; // pozicia vypisu 1. textu pocas startu aplikacie

 t_a=0; t_b=0; t_c=0; // pomocne premenne

 lighting_onoff=1;  // osvetlenie
 help_onoff=0;      // napoveda
 scene_draw_type=0; // standardny pohlad na scenu

 // poloha objektu, ktory vrha tien
 shadow_obj_pos[0]=0.0f; shadow_obj_pos[1]=0.0f; shadow_obj_pos[2]=0.0f;
 // rotacia objektu, ktory vrha tien
 shadow_obj_rot[0]=0.0f; shadow_obj_rot[1]=0.0f; shadow_obj_rot[2]=0.0f;
}

// destruktor **************************************************************
mOGL::~mOGL()
{

}

// vypis info pocas startu aplikacie ***************************************
void mOGL::PrintStartInfo(char *infotext)
{
 ogl_Text.OpenDrawString();
 ogl_Text.DrawString(10.0f,StartInfoPos,infotext);
 ogl_Text.CloseDrawString();

 // vymena zobrazovacich zasobnikov, zobrazenie sceny
 SDL_GL_SwapBuffers();

 // dalsi text bude vypisany na novu poziciu
 StartInfoPos+=20.0f;
 // pauza aby bol text aspon chvilku viditelny
 SDL_Delay(400);
}

// inicializacia OpenGL - nastavenie parametrov pre tvorbu OpenGL sceny ****
bool mOGL::gl_initialize(void)
{
 // nastavenie 8-mich vseobecnych materialov
 for (t_a=0;t_a<8;t_a++) {
  ogl_Material[t_a].amb[0]=0.3f; ogl_Material[t_a].amb[1]=0.3f;
  ogl_Material[t_a].amb[2]=0.3f; ogl_Material[t_a].amb[3]=1.0f;
  ogl_Material[t_a].dif[0]=0.6f; ogl_Material[t_a].dif[1]=0.6f;
  ogl_Material[t_a].dif[2]=0.6f; ogl_Material[t_a].dif[3]=1.0f;
  ogl_Material[t_a].spe[0]=1.0f; ogl_Material[t_a].spe[1]=1.0f;
  ogl_Material[t_a].spe[2]=1.0f; ogl_Material[t_a].spe[3]=1.0f;
  ogl_Material[t_a].amb_dif[0]=0.25f; ogl_Material[t_a].amb_dif[1]=0.25f;
  ogl_Material[t_a].amb_dif[2]=0.25f; ogl_Material[t_a].amb_dif[3]=1.0f;
  ogl_Material[t_a].emi[0]=0.0f; ogl_Material[t_a].emi[1]=0.0f;
  ogl_Material[t_a].emi[2]=0.0f; ogl_Material[t_a].emi[3]=1.0f;
  ogl_Material[t_a].shi=0.0f;
  ogl_Material[t_a].transp=0.0f;
  ogl_Material[t_a].sillum[0]=0.0f; ogl_Material[t_a].sillum[1]=0.0f;
  ogl_Material[t_a].sillum[2]=0.0f; ogl_Material[t_a].sillum[3]=1.0f;
 }
 // nastavenie 8-mich vseobecnych svetiel
 for (t_a=0;t_a<8;t_a++) {
  ogl_Light[t_a].amb[0]=0.25f; ogl_Light[t_a].amb[1]=0.25f;
  ogl_Light[t_a].amb[2]=0.25f; ogl_Light[t_a].amb[3]=1.0f;
  ogl_Light[t_a].dif[0]=0.5f; ogl_Light[t_a].dif[1]=0.5f;
  ogl_Light[t_a].dif[2]=0.5f; ogl_Light[t_a].dif[3]=1.0f;
  ogl_Light[t_a].spe[0]=0.75f; ogl_Light[t_a].spe[1]=0.75f;
  ogl_Light[t_a].spe[2]=0.75f; ogl_Light[t_a].spe[3]=1.0f;
  ogl_Light[t_a].pos[0]=0.0f; ogl_Light[t_a].pos[1]=0.0f;
  ogl_Light[t_a].pos[2]=0.0f; ogl_Light[t_a].pos[3]=1.0f;
  // pos[3]=1.0f - vsesmerove svetlo, 0.0f - smerove svetlo
  ogl_Light[t_a].spot[0]=0.0f;
  ogl_Light[t_a].spot[1]=0.0f;
  ogl_Light[t_a].spot[2]=-1.0f;
 }
 Lrotx=-20.0f; Lroty=-20.0f; Lposz=10.0f; // pociatocna rotacia a poloha svetla

 // STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ --

 // nastavenie OpenGL zasobnika farieb a hlbky *****************************
 glClearColor(0.0f,0.0f,0.0f,0.5f); // zasobnik farieb bude vymazavany ciernou farbou
 glClearDepth(1.0f);                // zasobnik hlbky bude vymazavany nastavenim na 1.0f
 glClearStencil(0);                 // stencil zasobnik bude vymazavany nastavenim na 0

 glDepthFunc(GL_LEQUAL);  // typ porovnavacej funkcie pre urcenie Z-vzdialenosti
 glEnable(GL_DEPTH_TEST); // zapnutie testovania hlbky

 glDisable(GL_CULL_FACE); // nastavenie poradia, v ktorom budu definovane vrcholy objektu
 glFrontFace(GL_CCW);     // reprezentovat privratene resp. odvratene plochy,
 glCullFace(GL_BACK);     // CCW - proti smeru hod. ruciciek, CW - v smere hod. ruciciek
 glEnable(GL_CULL_FACE);  // odvratene plochy sa nebudu spracovavat

 // nastavenie parametrov 1. OpenGL svetla
 glLightfv(GL_LIGHT0,GL_AMBIENT,ogl_Light[0].amb);
 glLightfv(GL_LIGHT0,GL_DIFFUSE,ogl_Light[0].dif);
 glLightfv(GL_LIGHT0,GL_SPECULAR,ogl_Light[0].spe);
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_Light[0].pos);
 glEnable(GL_LIGHT0); // ON
 // nastavenie parametrov 2. OpenGL svetla
 glLightfv(GL_LIGHT1,GL_AMBIENT,ogl_Light[1].amb);
 glLightfv(GL_LIGHT1,GL_DIFFUSE,ogl_Light[1].dif);
 glLightfv(GL_LIGHT1,GL_SPECULAR,ogl_Light[1].spe);
 glLightfv(GL_LIGHT1,GL_POSITION,ogl_Light[1].pos);
 //glEnable(GL_LIGHT1); // OFF
 if (lighting_onoff) glEnable(GL_LIGHTING);
 else glDisable(GL_LIGHTING);
 // svetlo sa pocita len pre privratene strany
 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,0);
 // svetelne vypocty su lokalne
 glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_TRUE);

 // vseobecny material objektov
 glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,ogl_Material[0].amb_dif);
 // farba bude mat vplyv iba na 'diffuse' komponent materialu
 glColorMaterial(GL_FRONT,GL_DIFFUSE);
 // pre Gourandove svetelne vypocty bude pouzity material priradeny objektu,
 // ktory bude ale stale ovplyvneny farbou zadavanou prikazom glColor
 glEnable(GL_COLOR_MATERIAL);
 // zapnutie gourand-jemneho tienovania
 glShadeModel(GL_SMOOTH);
 // trojuholniky budu vyplnene
 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

 // realnejsie perspektivne vypocty a korekcie
 glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);

 qo=gluNewQuadric();              // pre kvadraticke objekty
 gluQuadricNormals(qo,GL_SMOOTH); // zapnutie generovania normalovych vektorov
 gluQuadricTexture(qo,GL_FALSE);  // vypnutie generovania texturovacich suradnic

 // VYPNUTIE TEXTUROVANIA
 glDisable(GL_TEXTURE_2D);

 // INICIALIZACIA SCENY INICIALIZACIA SCENY INICIALIZACIA SCENY ------------

 // vymazanie zasobnika farieb, hlbky a stencil zasobnika
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT|GL_STENCIL_BUFFER_BIT);

 // inicializacia vypisovania OpenGL textu
 if (ogl_Text.TextInitialize()) {
  fprintf(stderr,"Chyba inicializacie fontu!\n"); return(1);
 }
 // potvrdenie startu OpenGL
 PrintStartInfo("Nastavenie OpenGL stavoveho stroja...");
 PrintStartInfo("OK");

 // zameriavaci kriz
 PrintStartInfo("Nahratie textury zameriavacieho kriza...");
 if (ogl_Texture.LoadCrosshairTexture("data/gfx/crosshair0.bmp")) {
  fprintf(stderr,"Chyba nahratia textury zameriavacieho kriza!\n"); return(1);
 }
 PrintStartInfo("OK");

 // objekt, ktory vrha tien
 PrintStartInfo("Nahratie objektu, kory vrha tien...");
 if (ReadShadowObject("data/cube.obj",&shadow_obj)) {
  fprintf(stderr,"Chyba nahratia objektu, ktory vrha tien!\n"); return(1);
 }
 ShadowObjectFaces(&shadow_obj); // priprava objektu pre vrhanie tiena
 PrintStartInfo("OK");

 // koniec pociatocnych nastaveni, zaciatok interakcie pozorovatela
 PrintStartInfo("START");

 // nastavenie farby a velkosti neskor vypisovaneho textu 
 ogl_Text.SetTextColor(1.0f,0.8f,0.0f);
 ogl_Text.SetTextSize(10);

 // nastavenie startovacej farby - biela
 glColor4f(1.0f,1.0f,1.0f,1.0f);

 return(0);
}

// vykreslenie OpenGL sceny ************************************************
int mOGL::gl_draw(void)
{
 // vymazanie zasobnika farieb, hlbky a stencil zasobnika
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT|GL_STENCIL_BUFFER_BIT);

 // zresetovanie modelovej matice
 glLoadIdentity();

 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 if (scene_draw_type==0) glMultMatrixf(ogl_Camera[Cnum].matrix);
 else {
  glRotatef(45.0f,1.0f,0.0f,0.0f);  // zapnutie specialneho pohladu na scenu
  glRotatef(-30.0f,0.0f,1.0f,0.0f);
 }
 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 if (scene_draw_type==0) glTranslatef(ogl_Camera[Cnum].posx,ogl_Camera[Cnum].posy,ogl_Camera[Cnum].posz);
 else glTranslatef(-7.5f,-10.0f,-15.0f); // v pripade specialneho pohladu na scenu

 // umiestenenie svetla na preddefinovanu poziciu
 glPushMatrix();
 glLoadIdentity();
 glRotatef(Lroty,0.0f,1.0f,0.0f);
 glRotatef(Lrotx,1.0f,0.0f,0.0f);
 glTranslatef(0.0f,0.0f,Lposz);
 glGetFloatv(GL_MODELVIEW_MATRIX,OGLM);
 // INFO: vypis prvkov nacitanej matice
 //fprintf(stderr,"%2.1f %2.1f %2.1f %2.1f\n",OGLM[0],OGLM[1],OGLM[2],OGLM[3]);
 //fprintf(stderr,"%2.1f %2.1f %2.1f %2.1f\n",OGLM[4],OGLM[5],OGLM[6],OGLM[7]);
 //fprintf(stderr,"%2.1f %2.1f %2.1f %2.1f\n",OGLM[8],OGLM[9],OGLM[10],OGLM[11]);
 //fprintf(stderr,"%2.1f %2.1f %2.1f %2.1f\n",OGLM[12],OGLM[13],OGLM[14],OGLM[15]);
 Lp0[0]=ogl_Light[0].pos[0]; Lp0[1]=ogl_Light[0].pos[1];
 Lp0[2]=ogl_Light[0].pos[2]; Lp0[3]=ogl_Light[0].pos[3];
 ogl_3Dmath.MatrixMul(OGLM,Lp0);
 // INFO: vypis vypocitanej polohy svetla
 //fprintf(stderr,"%2.1f %2.1f %2.1f %2.1f\n",Lp0[0],Lp0[1],Lp0[2],Lp0[3]);
 glLightfv(GL_LIGHT0,GL_POSITION,Lp0);
 glPopMatrix();

 // vypocet polohy svetla vo ztahu k lokalnemu suradnicovemu systemu objektu
 glPushMatrix();
 glLoadIdentity();
 // zaporna rotacia
 glRotatef(-shadow_obj_rot[1],0.0f,1.0f,0.0f);
 glRotatef(-shadow_obj_rot[0],1.0f,0.0f,0.0f);
 // zaporna poloha
 glTranslatef(-shadow_obj_pos[0],-shadow_obj_pos[1],-shadow_obj_pos[2]);
 glGetFloatv(GL_MODELVIEW_MATRIX,OGLM);
 Lp1[0]=Lp0[0]; Lp1[1]=Lp0[1];
 Lp1[2]=Lp0[2]; Lp1[3]=Lp0[3];
 ogl_3Dmath.MatrixMul(OGLM,Lp1);
 glPopMatrix();

 glPushMatrix();

 // vykreslenie stien miestnosti
 glColor4f(1.0f,1.0f,0.5f,1.0f); // zlto-biela farba
 glBegin(GL_QUADS);
  // podlaha
  glNormal3f(0.0f,1.0f,0.0f);
  glVertex3f(-20.0f,-20.0f,-20.0f); glVertex3f(-20.0f,-20.0f, 20.0f);
  glVertex3f( 20.0f,-20.0f, 20.0f); glVertex3f( 20.0f,-20.0f,-20.0f);
  // strop
  glNormal3f(0.0f,-1.0f,0.0f);
  glVertex3f(-20.0f, 20.0f, 20.0f); glVertex3f(-20.0f, 20.0f,-20.0f);
  glVertex3f( 20.0f, 20.0f,-20.0f); glVertex3f( 20.0f, 20.0f, 20.0f);
  // predna stena
  glNormal3f(0.0f,0.0f,1.0f);
  glVertex3f(-20.0f, 20.0f,-20.0f); glVertex3f(-20.0f,-20.0f,-20.0f);
  glVertex3f( 20.0f,-20.0f,-20.0f); glVertex3f( 20.0f, 20.0f,-20.0f);
  // zadna stena
  glNormal3f(0.0f,0.0f,-1.0f);
  glVertex3f( 20.0f, 20.0f, 20.0f); glVertex3f( 20.0f,-20.0f, 20.0f);
  glVertex3f(-20.0f,-20.0f, 20.0f); glVertex3f(-20.0f, 20.0f, 20.0f);
  // lava stena
  glNormal3f(1.0f,0.0f,0.0f);
  glVertex3f(-20.0f, 20.0f, 20.0f); glVertex3f(-20.0f,-20.0f, 20.0f);
  glVertex3f(-20.0f,-20.0f,-20.0f); glVertex3f(-20.0f, 20.0f,-20.0f);
  // prava stena
  glNormal3f(-1.0f,0.0f,0.0f);
  glVertex3f( 20.0f, 20.0f,-20.0f); glVertex3f( 20.0f,-20.0f,-20.0f);
  glVertex3f( 20.0f,-20.0f, 20.0f); glVertex3f( 20.0f, 20.0f, 20.0f);
 glEnd();

 // vykreslenie objektu, ktory vrha tien
 glTranslatef(shadow_obj_pos[0],shadow_obj_pos[1],shadow_obj_pos[2]);
 glRotatef(shadow_obj_rot[0],1.0f,0.0f,0.0f);
 glRotatef(shadow_obj_rot[1],0.0f,1.0f,0.0f);
 glColor4f(0.75f,0.0f,0.0f,1.0f); // cervena farba
 DrawShadowObject(shadow_obj);
 shadow_obj_rot[0]+=0.05f; // rotacia objektu
 shadow_obj_rot[1]+=0.05f;

 // vykreslenie tiena
 DrawShadow(shadow_obj,Lp1);

 glPopMatrix();

 // vykreslenie svetla
 glPushMatrix();
 glRotatef(Lroty,0.0f,1.0f,0.0f);
 glRotatef(Lrotx,1.0f,0.0f,0.0f);
 glTranslatef(0.0f,0.0f,Lposz);
 glColor4f(0.0f,0.0f,0.25f,1.0f); // modra farba
 gluCylinder(qo,0.2f,0.2f,0.8f,16,16);
 glTranslatef(0.0f,0.0f,0.8f);
 gluCylinder(qo,0.2f,0.0f,0.0f,16,16);
 glTranslatef(0.0f,0.0f,-1.1f);
 glDisable(GL_CULL_FACE);
 gluCylinder(qo,0.4f,0.0f,0.6f,16,16);
 glEnable(GL_CULL_FACE);
 glPopMatrix();

 glColor4f(1.0f,1.0f,1.0f,1.0f); // biela farba - standard

 // vykreslenie zameriavacieho kriza
 ogl_Texture.DrawCrosshair(ogl_Camera[Cnum].scr_w,ogl_Camera[Cnum].scr_h);

 if (help_onoff) {
  // vypis textu - help
  ogl_Text.OpenDrawString();

  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-20.0f, "ESC ukoncenie aplikacie");

  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-60.0f, "MYS                rotacia v danom smere");
  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-80.0f, "SIPKY              posun dopredu,dozadu,vlavo,vpravo");
  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-100.0f,"SHIFT              zrychlenie posunu");

  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-140.0f,"R     reinicializacia pohladu kamery");
  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-160.0f,"M     vyplnene trojuholniky/iba hrany trojuholnikov");

  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-200.0f,"X     rotacia svetla dolava");
  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-220.0f,"C     rotacia svetla doprava");
  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-240.0f,"F     rotacia svetla hore");
  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-260.0f,"V     rotacia svetla dole");
  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-280.0f,"G     posun svetla dopredu");
  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-300.0f,"B     posun svetla dozadu");
  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-320.0f,"SPACE zmena pohladu na scenu");

  ogl_Text.DrawString(10.0f,ogl_Camera[Cnum].scr_h-360.0f,"H     zapnutie/vypnutie zobrazenia helpu");

  ogl_Text.CloseDrawString();
 }
 else {
  // vypis textu - poloha kamery
  ogl_Text.OpenDrawString();

  sprintf(ogl_Text.numberbuf,"x:%6.2f",-ogl_Camera[Cnum].posx);
  ogl_Text.DrawNumber(10.0f,30.0f);
  sprintf(ogl_Text.numberbuf,"y:%6.2f",-ogl_Camera[Cnum].posy);
  ogl_Text.DrawNumber(10.0f,20.0f);
  sprintf(ogl_Text.numberbuf,"z:%6.2f",-ogl_Camera[Cnum].posz);
  ogl_Text.DrawNumber(10.0f,10.0f);

  // vypis textu - pocet obrazkov za sekundu
  sprintf(ogl_Text.numberbuf,"%i fps",(GLuint) ogl_Camera[Cnum].ogl_fps);
  ogl_Text.DrawNumber(10.0f,ogl_Camera[Cnum].scr_h-20.0f);

  ogl_Text.CloseDrawString();
 }

 return(0);
}

// casovo zavisla uprava objektov, resp. sceny *****************************
int mOGL::gl_iddle(void)
{

 return(0);
}

// zmena sposobu zobrazenia objektov ***************************************
void mOGL::change_PolygonMode(void)
{
 glGetIntegerv(GL_POLYGON_MODE,&ogl_State[0]);
 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"ogl_State=%d\n",ogl_State[0]);

 if (ogl_State[0]==GL_LINE) glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
 else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

 SDL_Delay(200);
}

// zap/vyp vypisu helpu ****************************************************
void mOGL::change_HelpOnOff(void)
{
 if (help_onoff==0) help_onoff=1;
 else help_onoff=0;

 SDL_Delay(200);
}

// zmena pohladu na scenu **************************************************
void mOGL::change_DrawType(void)
{
 if (scene_draw_type==0) scene_draw_type=1;
 else scene_draw_type=0;
 
 SDL_Delay(200);
}

// zmena polohy svetla *****************************************************
void mOGL::change_LightPos(GLfloat x,GLfloat y,GLfloat z)
{
 Lrotx+=x; Lroty+=y;

 if (z<0.0f) {
  if (Lposz>4.0) Lposz+=z;
 }
 else {
  if (Lposz<14.0f) Lposz+=z;
 }
}

// nacitanie objektu zo suboru *********************************************
int mOGL::ReadShadowObject(char *datafile,s3DObject *obj)
{
 FILE *file; // soubor
 file=fopen(datafile,"r"); // otvorenie suboru
 if (!file) return(1);

 fscanf(file,"%d",&(obj->nPoints));    // pocet vrcholov
 for (t_a=1;t_a<=obj->nPoints;t_a++) { // nacitanie vrcholov, zacina sa od 1
  fscanf(file,"%f",&(obj->points[t_a].x));
  fscanf(file,"%f",&(obj->points[t_a].y));
  fscanf(file,"%f",&(obj->points[t_a].z));
 }

 fscanf(file,"%d",&(obj->nFaces));   // pocet facov
 for (t_a=0;t_a<obj->nFaces;t_a++) { // nacitanie facov, zacina sa od 0
  fscanf(file,"%d",&(obj->faces[t_a].p[0]));
  fscanf(file,"%d",&(obj->faces[t_a].p[1]));
  fscanf(file,"%d",&(obj->faces[t_a].p[2]));
  fscanf(file,"%f",&(obj->faces[t_a].normals[0].x));
  fscanf(file,"%f",&(obj->faces[t_a].normals[0].y));
  fscanf(file,"%f",&(obj->faces[t_a].normals[0].z));
  fscanf(file,"%f",&(obj->faces[t_a].normals[1].x));
  fscanf(file,"%f",&(obj->faces[t_a].normals[1].y));
  fscanf(file,"%f",&(obj->faces[t_a].normals[1].z));
  fscanf(file,"%f",&(obj->faces[t_a].normals[2].x));
  fscanf(file,"%f",&(obj->faces[t_a].normals[2].y));
  fscanf(file,"%f",&(obj->faces[t_a].normals[2].z));

  obj->faces[t_a].neigh[0]=0; // ziadna z hran facu este nema suseda
  obj->faces[t_a].neigh[1]=0;
  obj->faces[t_a].neigh[2]=0;
 }

 fclose(file); // zatvorenie suboru

 return(0);
}

// priprava objektu pre vrhanie tiena **************************************
void mOGL::ShadowObjectFaces(s3DObject *obj)
{
 GLuint i,j,k,l,m;   // pomocne premenne
 GLuint a1,a2,b1,b2; // pomocne premenne
 //GLuint c1,c2,d1,d2; // pomocne premenne

 // vypocet prvkov rovnice roviny pre kazdy face
 for (i=0;i<obj->nFaces;i++) {
  ogl_3Dmath.CalcPlane(obj,&(obj->faces[i]));
 }

 m=0; // pocitadlo susednych facov
 for (i=0;i<obj->nFaces-1;i++) {   // 1. a nasledujuce facy objektu
  for (j=i+1;j<obj->nFaces;j++) {  // 2. a nasledujuce facy objektu
   for (k=0;k<3;k++) {             // pre kazdu hranu 1. facu
    if (!obj->faces[i].neigh[k]) { // ak hrana este nema suseda
     for (l=0;l<3;l++) {           // pre kazdu hranu 2. facu
      a1=k; b1=(k+1)%3; // 1. a 2. vrchol 1. hrany (0->1 1->2 2->0)
      a2=l; b2=(l+1)%3; // 1. a 2. vrchol 2. hrany

	  // ziskanie indexu pre pozadovany vrchol
      a1=obj->faces[i].p[a1]; b1=obj->faces[i].p[b1];
      a2=obj->faces[j].p[a2]; b2=obj->faces[j].p[b2];

	  // poradie vrcholov moze byt rozdielne, na porovnanie indexov mozno
      // pouzit nasledovny vypocet, alebo mozno tiez pouzit krizove porovnanie indexov
      //c1=((a1+b1)-ogl_3Dmath.myAbs(a1-b1))/2; d1=((a1+b1)+ogl_3Dmath.myAbs(a1-b1))/2;
      //c2=((a2+b2)-ogl_3Dmath.myAbs(a2-b2))/2; d2=((a2+b2)+ogl_3Dmath.myAbs(a2-b2))/2;

      // porovnenie na zaklade predosleho vypoctu
      //if ((c1==c2)&&(d1==d2)) {
	  // krizove porovnanie indexov (0=0 a 1=1 alebo 0=1 a 1=0)
	  if (((a1==a2)&&(b1==b2))||((a1==b2)&&(b1==a2))) { 
       obj->faces[i].neigh[k]=j+1; // zvysenie indexu susedneho facu o 1*
       obj->faces[j].neigh[l]=i+1; // 0 znamena, ze hrana nema suseda
	   m++;
	   // INFO: indexy susednych hran
	   //fprintf(stderr,"%d %d %d\n",j+1,i+1,m);
      }
     }
    }
   }
  }
 }
}

// vykreslenie objektu *****************************************************
void mOGL::DrawShadowObject(s3DObject obj)
{
 glBegin(GL_TRIANGLES); // budu sa kreslit trojuholniky
  for (t_a=0;t_a<obj.nFaces;t_a++) { // vsetky facy objektu
   for (t_b=0;t_b<3;t_b++) {         // vsetky vrcholy kazdeho facu
    glNormal3f(obj.faces[t_a].normals[t_b].x,
 	           obj.faces[t_a].normals[t_b].y,
	           obj.faces[t_a].normals[t_b].z);
    glVertex3f(obj.points[obj.faces[t_a].p[t_b]].x,
               obj.points[obj.faces[t_a].p[t_b]].y,
               obj.points[obj.faces[t_a].p[t_b]].z);
   }
  }
 glEnd();
  
 // INFO: vykreslenie normal vsetkych facov objektu
 /*
 glDisable(GL_LIGHTING);
 glColor4f(0.0f,1.0f,0.0f,1.0f); 
 glBegin(GL_LINES);
  for (t_a=0;t_a<obj.nFaces;t_a++) {
   for (t_b=0;t_b<3;t_b++) {
	glVertex3f(obj.points[obj.faces[t_a].p[t_b]].x,
               obj.points[obj.faces[t_a].p[t_b]].y,
               obj.points[obj.faces[t_a].p[t_b]].z);
    glVertex3f(obj.points[obj.faces[t_a].p[t_b]].x+obj.faces[t_a].PlaneEq.a,
               obj.points[obj.faces[t_a].p[t_b]].y+obj.faces[t_a].PlaneEq.b,
               obj.points[obj.faces[t_a].p[t_b]].z+obj.faces[t_a].PlaneEq.c);
   }
  }
 glEnd();
 glColor4f(1.0f,1.0f,1.0f,1.0f); 
 glEnable(GL_LIGHTING);
 */
}

// vykreslenie tiena *******************************************************
void mOGL::DrawShadow(s3DObject obj,float *lightpos)
{
 // urcenie polohy svetla a steny (facu) objektu
 // predpoklady:
 //  kazdy face ma svoju rovnicu roviny ax+by+cz+d=0
 //  x,y,z,d bude poloha svetla
 //  kladny vysledok - svetlo lezi pred facom - face je osvetleny
 //  zaporny vysledok - svetlo lezi za facom
 for (t_a=0;t_a<obj.nFaces;t_a++) {
  S=obj.faces[t_a].PlaneEq.a*lightpos[0]+obj.faces[t_a].PlaneEq.b*lightpos[1]+
    obj.faces[t_a].PlaneEq.c*lightpos[2]+obj.faces[t_a].PlaneEq.d*lightpos[3];

  if (S>0.0f) obj.faces[t_a].visible=true; // face je osvetleny
  else obj.faces[t_a].visible=false;       // face nie je osvetleny
 }

 // nasleduje vypnutie osvetlenia, renderingu do zasobnika hlbky a
 // zasobnika farieb a zapnutie pouzitia stencil zasobnika
 glDisable(GL_LIGHTING); // vypnutie osvetlenia

 glDepthMask(GL_FALSE);  // vypnutie zasobnika hlbky
 glColorMask(0,0,0,0);   // vypnutie zasobnika farieb

 glStencilFunc(GL_ALWAYS,1,0xffffffff); // stencil funkcia
 glStencilOp(GL_KEEP,GL_KEEP,GL_INCR);  // zvacsovanie hodnot ulozenych v stencil zasobniku
 glEnable(GL_STENCIL_TEST);             // zapnutie stencil testov

 // najdenie okrajov objektu
 for (t_a=0;t_a<obj.nFaces;t_a++) {
  if (obj.faces[t_a].visible) {    // ak je stena (face) viditelna
   for (t_b=0;t_b<3;t_b++) {       // pre kazdu hranu facu
    t_c=obj.faces[t_a].neigh[t_b]; // index suseda
	// ak neexistuje sused alebo tento nie je privrateny k svetlu
    if ((!t_c)||(!obj.faces[t_c-1].visible)) { // znizenie indexu susedneho facu o 1*
     P1=obj.faces[t_a].p[t_b];         // 1. bod okraja
     P2=obj.faces[t_a].p[((t_b+1)%3)]; // 2. bod okraja
     // vypocet prvkov vektora svetlo -> 1. bod facu
     V1.x=(obj.points[P1].x-lightpos[0])*100.0f;
     V1.y=(obj.points[P1].y-lightpos[1])*100.0f;
     V1.z=(obj.points[P1].z-lightpos[2])*100.0f;
	 // vypocet prvkov vektora svetlo -> 2. bod facu
     V2.x=(obj.points[P2].x-lightpos[0])*100.0f;
     V2.y=(obj.points[P2].y-lightpos[1])*100.0f;
     V2.z=(obj.points[P2].z-lightpos[2])*100.0f;
     // vykreslenie okrajoveho polygonu tiena
     glBegin(GL_TRIANGLE_STRIP);
      glVertex3f(obj.points[P1].x,obj.points[P1].y,obj.points[P1].z);
      glVertex3f(obj.points[P1].x+V1.x,obj.points[P1].y+V1.y,obj.points[P1].z+V1.z);
      glVertex3f(obj.points[P2].x,obj.points[P2].y,obj.points[P2].z);
      glVertex3f(obj.points[P2].x+V2.x,obj.points[P2].y+V2.y,obj.points[P2].z+V2.z);
     glEnd();
    }
   }
  }
 }

 glStencilOp(GL_KEEP,GL_KEEP,GL_DECR); // zmensovanie hodnot ulozenych v stencil zasobniku

 glFrontFace(GL_CW); // otocenie poradia vrcholov privratenej face

 // do stencil zasobnika sa "vykreslia" iba odvratene steny, dojde tak k zmazaniu
 // tych oblasti stencil zasobnika, ktore sa nemaju vo vyslednom tieni vykreslit,
 // kod je totozny s predoslym, obratenim poradia vrcholov definujucich face (GL_CW)
 // vsak ziskame pozadovany efekt
 for (t_a=0;t_a<obj.nFaces;t_a++) {
  if (obj.faces[t_a].visible) {    // ak je stena (face) viditelna
   for (t_b=0;t_b<3;t_b++) {       // pre kazdu hranu facu
    t_c=obj.faces[t_a].neigh[t_b]; // index suseda
	// ak neexistuje sused alebo tento nie je privrateny k svetlu
    if ((!t_c)||(!obj.faces[t_c-1].visible)) { // znizenie indexu susedneho facu o 1*
     P1=obj.faces[t_a].p[t_b];         // 1. bod okraja
     P2=obj.faces[t_a].p[((t_b+1)%3)]; // 2. bod okraja
     // vypocet prvkov vektora svetlo -> 1. bod facu
     V1.x=(obj.points[P1].x-lightpos[0])*100.0f;
     V1.y=(obj.points[P1].y-lightpos[1])*100.0f;
     V1.z=(obj.points[P1].z-lightpos[2])*100.0f;
     // vypocet prvkov vektora svetlo -> 2. bod facu
     V2.x=(obj.points[P2].x-lightpos[0])*100.0f;
     V2.y=(obj.points[P2].y-lightpos[1])*100.0f;
     V2.z=(obj.points[P2].z-lightpos[2])*100.0f;
     // vykreslenie okrajoveho polygonu tiena
     glBegin(GL_TRIANGLE_STRIP);
      glVertex3f(obj.points[P1].x,obj.points[P1].y,obj.points[P1].z);
      glVertex3f(obj.points[P1].x+V1.x,obj.points[P1].y+V1.y,obj.points[P1].z+V1.z);
      glVertex3f(obj.points[P2].x,obj.points[P2].y,obj.points[P2].z);
      glVertex3f(obj.points[P2].x+V2.x,obj.points[P2].y+V2.y,obj.points[P2].z+V2.z);
     glEnd();
    }
   }
  }
 }

 glFrontFace(GL_CCW); // otocenie poradia vrcholov privratenej face

 glColorMask(1,1,1,1); // zapnutie zasobnika farieb - kreslenie na obrazovku

 glEnable(GL_BLEND);                               // zapnutie priehladnosti
 glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA); // sposob vypoctu priehladnosti

 glStencilFunc(GL_NOTEQUAL,0,0xffffffff); // stencil funkcia
 glStencilOp(GL_KEEP,GL_KEEP,GL_KEEP);    // hodnoty ulozene v stencil zasobniku nebudu menene

 // vykreslenie dostatocne velkeho stvoruholnika do pohladu kamery
 // vykreslia sa iba tie body, ktore "maju 1" v stencil zasobniku
 glColor4f(0.0f,0.0f,0.0f,0.3f); // cierna 30% priehladna farba
 glPushMatrix();
 glLoadIdentity();
 glBegin(GL_TRIANGLE_STRIP);
  glVertex3f(-0.1f, 0.1f,-0.1f); glVertex3f(-0.1f,-0.1f,-0.1f);
  glVertex3f( 0.1f, 0.1f,-0.1f); glVertex3f( 0.1f,-0.1f,-0.1f);
 glEnd();
 glPopMatrix();

 glDisable(GL_BLEND);        // vypnutie priehladnosti

 glDisable(GL_STENCIL_TEST); // vypnutie stencil testov

 glDepthMask(GL_TRUE);       // zapnutie zasobnika hlbky

 glEnable(GL_LIGHTING);      // zapnutie osvetlenia
}
